## likwid 5.1.0+dfsg1

=== Makefile ===
# =======================================================================================
#
#      Filename:  Makefile
#
#      Description:  Central Makefile
#
#      Version:   5.1.0
#      Released:  20.11.2020
#
#      Author:  Jan Treibig (jt), jan.treibig@gmail.com
#      Project:  likwid
#
#      Copyright (C) 2020 RRZE, University Erlangen-Nuremberg
#
#      This program is free software: you can redistribute it and/or modify it under
#      the terms of the GNU General Public License as published by the Free Software
#      Foundation, either version 3 of the License, or (at your option) any later
#      version.
#
#      This program is distributed in the hope that it will be useful, but WITHOUT ANY
#      WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
#      PARTICULAR PURPOSE.  See the GNU General Public License for more details.
#
#      You should have received a copy of the GNU General Public License along with
#      this program.  If not, see <http://www.gnu.org/licenses/>.
#
# =======================================================================================

SRC_DIR     = ./src
DOC_DIR     = ./doc
GROUP_DIR   = ./groups
FILTER_DIR  = ./filters
MAKE_DIR    = ./make

Q         ?= @

#DO NOT EDIT BELOW

# Dependency chains:
# *.[ch] -> *.o -> executables
# *.ptt -> *.pas -> *.s -> *.o -> executables
# *.txt -> *.h (generated)

include ./config.mk
include $(MAKE_DIR)/include_$(COMPILER).mk
include $(MAKE_DIR)/config_git.mk
include $(MAKE_DIR)/config_checks.mk
include $(MAKE_DIR)/config_defines.mk

INCLUDES  += -I./src/includes -I$(LUA_INCLUDE_DIR) -I$(HWLOC_FOLDER)/include -I$(BUILD_DIR)
LIBS      += -ldl

ifeq ($(LUA_INTERNAL),false)
LIBS      += -l$(LUA_LIB_NAME)
endif

#CONFIGURE BUILD SYSTEM
BUILD_DIR  = ./$(COMPILER)
Q         ?= @
GENGROUPLOCK = .gengroup

VPATH     = $(SRC_DIR)
OBJ       = $(patsubst $(SRC_DIR)/%.c, $(BUILD_DIR)/%.o,$(wildcard $(SRC_DIR)/*.c))
OBJ      += $(patsubst $(SRC_DIR)/%.cc, $(BUILD_DIR)/%.o,$(wildcard $(SRC_DIR)/*.cc))
OBJ      += $(patsubst $(SRC_DIR)/%.S, $(BUILD_DIR)/%.o,$(wildcard $(SRC_DIR)/*.S))
ifeq ($(FILTER_HWLOC_OBJ),yes)
OBJ := $(filter-out $(BUILD_DIR)/topology_hwloc.o,$(OBJ))
OBJ := $(filter-out $(BUILD_DIR)/numa_hwloc.o,$(OBJ))
OBJ := $(filter-out $(BUILD_DIR)/pci_hwloc.o,$(OBJ))
endif
ifneq ($(FORTRAN_INTERFACE),true)
OBJ := $(filter-out $(BUILD_DIR)/likwid_f90_interface.o,$(OBJ))
endif
ifeq ($(COMPILER), GCCARMv7)
OBJ := $(filter-out $(BUILD_DIR)/topology_cpuid.o,$(OBJ))
OBJ := $(filter-out $(BUILD_DIR)/loadData.o,$(OBJ))
OBJ := $(filter-out $(BUILD_DIR)/access_x86.o,$(OBJ))
OBJ := $(filter-out $(BUILD_DIR)/access_x86_msr.o,$(OBJ))
OBJ := $(filter-out $(BUILD_DIR)/access_x86_pci.o,$(OBJ))
OBJ := $(filter-out $(BUILD_DIR)/access_x86_clientmem.o,$(OBJ))
else
OBJ := $(filter-out $(BUILD_DIR)/loadDataARM.o,$(OBJ))
endif
ifeq ($(COMPILER), GCCARMv8)
OBJ := $(filter-out $(BUILD_DIR)/topology_cpuid.o,$(OBJ))
OBJ := $(filter-out $(BUILD_DIR)/loadData.o,$(OBJ))
OBJ := $(filter-out $(BUILD_DIR)/access_x86.o,$(OBJ))
OBJ := $(filter-out $(BUILD_DIR)/access_x86_msr.o,$(OBJ))
OBJ := $(filter-out $(BUILD_DIR)/access_x86_pci.o,$(OBJ))
OBJ := $(filter-out $(BUILD_DIR)/access_x86_clientmem.o,$(OBJ))
else
OBJ := $(filter-out $(BUILD_DIR)/loadDataARM.o,$(OBJ))
endif
ifeq ($(COMPILER), ARMCLANG)
OBJ := $(filter-out $(BUILD_DIR)/topology_cpuid.o,$(OBJ))
OBJ := $(filter-out $(BUILD_DIR)/loadData.o,$(OBJ))
OBJ := $(filter-out $(BUILD_DIR)/access_x86.o,$(OBJ))
OBJ := $(filter-out $(BUILD_DIR)/access_x86_msr.o,$(OBJ))
OBJ := $(filter-out $(BUILD_DIR)/access_x86_pci.o,$(OBJ))
OBJ := $(filter-out $(BUILD_DIR)/access_x86_clientmem.o,$(OBJ))
else
OBJ := $(filter-out $(BUILD_DIR)/loadDataARM.o,$(OBJ))
endif
ifneq ($(NVIDIA_INTERFACE), true)
OBJ := $(filter-out $(BUILD_DIR)/nvmon.o,$(OBJ))
OBJ := $(filter-out $(BUILD_DIR)/topology_gpu.o,$(OBJ))
OBJ := $(filter-out $(BUILD_DIR)/libnvctr.o,$(OBJ))
endif
ifeq ($(COMPILER),GCCPOWER)
OBJ := $(filter-out $(BUILD_DIR)/topology_cpuid.o,$(OBJ))
OBJ := $(filter-out $(BUILD_DIR)/access_x86.o,$(OBJ))
OBJ := $(filter-out $(BUILD_DIR)/access_x86_msr.o,$(OBJ))
OBJ := $(filter-out $(BUILD_DIR)/access_x86_pci.o,$(OBJ))
OBJ := $(filter-out $(BUILD_DIR)/access_x86_clientmem.o,$(OBJ))
OBJ := $(filter-out $(BUILD_DIR)/loadData.o,$(OBJ))
endif
ifeq ($(COMPILER),XLC)
OBJ := $(filter-out $(BUILD_DIR)/topology_cpuid.o,$(OBJ))
OBJ := $(filter-out $(BUILD_DIR)/access_x86.o,$(OBJ))
OBJ := $(filter-out $(BUILD_DIR)/access_x86_msr.o,$(OBJ))
OBJ := $(filter-out $(BUILD_DIR)/access_x86_pci.o,$(OBJ))
OBJ := $(filter-out $(BUILD_DIR)/access_x86_clientmem.o,$(OBJ))
OBJ := $(filter-out $(BUILD_DIR)/loadData.o,$(OBJ))
endif
PERFMONHEADERS  = $(patsubst $(SRC_DIR)/includes/%.txt, $(BUILD_DIR)/%.h,$(wildcard $(SRC_DIR)/includes/*.txt))
OBJ_LUA    =  $(wildcard ./ext/lua/$(COMPILER)/*.o)
OBJ_HWLOC  =  $(wildcard ./ext/hwloc/$(COMPILER)/*.o)
OBJ_GOTCHA = $(wildcard ./ext/GOTCHA/$(COMPILER)/*.o)
FILTERS := $(filter-out ./filters/README,$(wildcard ./filters/*))


L_APPS      =   likwid-perfctr \
				likwid-pin \
				likwid-powermeter \
				likwid-topology \
				likwid-memsweeper \
				likwid-mpirun \
				likwid-features \
				likwid-perfscope \
				likwid-genTopoCfg
C_APPS      =   bench/likwid-bench
L_HELPER    =   likwid.lua
ifeq ($(BUILDFREQ),true)
	L_APPS += likwid-setFrequencies
endif

CPPFLAGS := $(CPPFLAGS) $(DEFINES) $(INCLUDES)

ifeq ($(BUILDDAEMON),false)
all: $(BUILD_DIR) $(PERFMONHEADERS) $(OBJ) $(TARGET_LIB) $(FORTRAN_IF)  $(PINLIB) $(L_APPS) $(L_HELPER) $(FREQ_TARGET) $(BENCH_TARGET) $(APPDAEMON_TARGET)
else
ifeq ($(BUILDFREQ),false)
all: $(BUILD_DIR) $(PERFMONHEADERS) $(OBJ) $(TARGET_LIB) $(FORTRAN_IF)  $(PINLIB) $(L_APPS) $(L_HELPER) $(DAEMON_TARGET) $(BENCH_TARGET) $(APPDAEMON_TARGET)
else
all: $(BUILD_DIR) $(PERFMONHEADERS) $(OBJ) $(TARGET_LIB) $(FORTRAN_IF)  $(PINLIB) $(L_APPS) $(L_HELPER) $(DAEMON_TARGET) $(FREQ_TARGET) $(BENCH_TARGET) $(APPDAEMON_TARGET)
endif
endif

tags:
	@echo "===>  GENERATE  TAGS"
	$(Q)ctags -R

docs:
	@echo "===>  GENERATE DOXYGEN DOCS"
	@cp doc/lua-doxygen.md doc/lua-doxygen.md.safe
	@cp doc/likwid-doxygen.md doc/likwid-doxygen.md.safe
	@sed -i -e s+'<PREFIX>'+$(PREFIX)+g -e s+'<VERSION>'+$(VERSION)+g -e s+'<DATE>'+'$(DATE)'+g -e s+'<RELEASE>'+$(RELEASE)+g -e s+'<MINOR>'+$(MINOR)+g -e s+'<GITCOMMIT>'+$(GITCOMMIT)+g doc/lua-doxygen.md
	@sed -i -e s+'<PREFIX>'+$(PREFIX)+g -e s+'<VERSION>'+$(VERSION)+g -e s+'<DATE>'+'$(DATE)'+g -e s+'<RELEASE>'+$(RELEASE)+g -e s+'<MINOR>'+$(MINOR)+g -e s+'<GITCOMMIT>'+$(GITCOMMIT)+g doc/likwid-doxygen.md
	$(Q)doxygen doc/Doxyfile
	@mv doc/lua-doxygen.md.safe doc/lua-doxygen.md
	@mv doc/likwid-doxygen.md.safe doc/likwid-doxygen.md

$(L_APPS):  $(addprefix $(SRC_DIR)/applications/,$(addsuffix  .lua,$(L_APPS)))
	@echo "===>  ADJUSTING  $@"
	@if [ "$(ACCESSMODE)" = "direct" ]; then sed -i -e s/"access_mode = 1"/"access_mode = 0"/g $(SRC_DIR)/applications/$@.lua;fi
	@sed -e s/'<INSTALLED_BINPREFIX>'/$(subst /,\\/,$(INSTALLED_BINPREFIX))/g \
		-e s/'<INSTALLED_PREFIX>'/$(subst /,\\/,$(INSTALLED_PREFIX))/g \
		-e s/'<VERSION>'/$(VERSION).$(RELEASE).$(MINOR)/g \
		-e s/'<DATE>'/$(DATE)/g \
		-e s/'<RELEASE>'/$(RELEASE)/g \
		-e s/'<MINOR>'/$(MINOR)/g \
		-e s/'<GITCOMMIT>'/$(GITCOMMIT)/g \
		$(addprefix $(SRC_DIR)/applications/,$(addsuffix  .lua,$@)) > $@
	@if [ "$(LUA_INTERNAL)" = "false" ]; then \
		sed -i -e s+"$(subst /,\\/,$(INSTALLED_BINPREFIX))/likwid-lua"+"$(LUA_BIN)/$(LUA_LIB_NAME)"+ $@; \
	fi
	@if [ "$(ACCESSMODE)" = "direct" ]; then sed -i -e s/"access_mode = 0"/"access_mode = 1"/g $(SRC_DIR)/applications/$@.lua;fi

$(L_HELPER):
	@echo "===>  ADJUSTING  $@"
	@sed -e s/'<PREFIX>'/$(subst /,\\/,$(PREFIX))/g \
		-e s/'<INSTALLED_LIBPREFIX>'/$(subst /,\\/,$(INSTALLED_LIBPREFIX))/g \
		-e s/'<INSTALLED_PREFIX>'/$(subst /,\\/,$(INSTALLED_PREFIX))/g \
		-e s/'<LIKWIDGROUPPATH>'/$(subst /,\\/,$(LIKWIDGROUPPATH))/g \
		-e s/'<LIBLIKWIDPIN>'/$(subst /,\\/,$(LIBLIKWIDPIN))/g \
		-e s/'<VERSION>'/$(VERSION)/g \
		-e s/'<RELEASE>'/$(RELEASE)/g \
		-e s/'<MINOR>'/$(MINOR)/g \
		-e s/'<GITCOMMIT>'/$(GITCOMMIT)/g \
		$(SRC_DIR)/applications/$@ > $@

$(STATIC_TARGET_LIB): $(BUILD_DIR) $(PERFMONHEADERS) $(OBJ) $(TARGET_HWLOC_LIB) $(TARGET_LUA_LIB)
	@echo "===>  CREATE STATIC LIB  $(TARGET_LIB)"
	$(Q)${AR} -crs $(STATIC_TARGET_LIB) $(OBJ) $(TARGET_HWLOC_LIB) $(TARGET_LUA_LIB)
	@sed -e s+'@PREFIX@'+$(INSTALLED_PREFIX)+g \
		-e s+'@NVIDIA_INTERFACE@'+$(NVIDIA_INTERFACE)+g \
		-e s+'@FORTRAN_INTERFACE@'+$(FORTRAN_INTERFACE)+g \
		-e s+'@LIBPREFIX@'+$(INSTALLED_LIBPREFIX)+g \
		-e s+'@BINPREFIX@'+$(INSTALLED_BINPREFIX)+g \
		make/likwid-config.cmake > likwid-config.cmake

$(DYNAMIC_TARGET_LIB): $(BUILD_DIR) $(PERFMONHEADERS) $(OBJ) $(TARGET_HWLOC_LIB) $(TARGET_LUA_LIB)
	@echo "===>  CREATE SHARED LIB  $(TARGET_LIB)"
	$(Q)${CC} $(DEBUG_FLAGS) $(SHARED_LFLAGS) -Wl,-soname,$(TARGET_LIB).$(VERSION).$(RELEASE) $(SHARED_CFLAGS) -o $(DYNAMIC_TARGET_LIB) $(OBJ) $(LIBS) $(TARGET_HWLOC_LIB) $(TARGET_LUA_LIB) $(RPATHS)
	@ln -sf $(TARGET_LIB) $(TARGET_LIB).$(VERSION).$(RELEASE)
	@sed -e s+'@PREFIX@'+$(INSTALLED_PREFIX)+g \
		-e s+'@NVIDIA_INTERFACE@'+$(NVIDIA_INTERFACE)+g \
		-e s+'@FORTRAN_INTERFACE@'+$(FORTRAN_INTERFACE)+g \
		-e s+'@LIBPREFIX@'+$(INSTALLED_LIBPREFIX)+g \
		-e s+'@BINPREFIX@'+$(INSTALLED_BINPREFIX)+g \
		make/likwid-config.cmake > likwid-config.cmake

$(DAEMON_TARGET): $(SRC_DIR)/access-daemon/accessDaemon.c
	@echo "===>  BUILD access daemon likwid-accessD"
	$(Q)$(MAKE) -C  $(SRC_DIR)/access-daemon likwid-accessD

$(FREQ_TARGET): $(SRC_DIR)/access-daemon/setFreqDaemon.c
	@echo "===>  BUILD frequency daemon likwid-setFreq"
	$(Q)$(MAKE) -C  $(SRC_DIR)/access-daemon likwid-setFreq

$(APPDAEMON_TARGET): $(SRC_DIR)/access-daemon/appDaemon.c $(TARGET_GOTCHA_LIB)
	@echo "===>  BUILD application interface likwid-appDaemon.so"
	$(Q)$(MAKE) -C  $(SRC_DIR)/access-daemon likwid-appDaemon.so

$(BUILD_DIR):
	@mkdir $(BUILD_DIR)

$(PINLIB):
	@echo "===>  CREATE LIB  $(PINLIB)"
	$(Q)$(MAKE) -C src/pthread-overload/ $(PINLIB)

$(GENGROUPLOCK): $(foreach directory,$(shell ls $(GROUP_DIR)), $(wildcard $(GROUP_DIR)/$(directory)/*.txt))
	@echo "===>  GENERATE GROUP HEADERS"
	$(Q)$(GEN_GROUPS) ./groups  $(BUILD_DIR) ./perl/templates
	$(Q)touch $(GENGROUPLOCK)

$(FORTRAN_IF): $(SRC_DIR)/likwid.f90
	@echo "===>  COMPILE FORTRAN INTERFACE  $@"
	$(Q)$(FC) -c  $(FCFLAGS) $<
	@rm -f likwid.o

ifeq ($(LUA_INTERNAL),true)
$(TARGET_LUA_LIB):
	@echo "===>  ENTER  $(LUA_FOLDER)"
	$(Q)$(MAKE) --no-print-directory -C $(LUA_FOLDER) $(MAKECMDGOALS)
else
$(TARGET_LUA_LIB):
	@echo "===>  EXTERNAL LUA"
endif

$(TARGET_GOTCHA_LIB):
	@echo "===>  ENTER  $(GOTCHA_FOLDER)"
	$(Q)$(MAKE) --no-print-directory -C $(GOTCHA_FOLDER) $(MAKECMDGOALS)


$(TARGET_HWLOC_LIB):
	@echo "===>  ENTER  $(HWLOC_FOLDER)"
	$(Q)$(MAKE) --no-print-directory -C $(HWLOC_FOLDER) $(MAKECMDGOALS)

$(BENCH_TARGET):
	@echo "===>  ENTER  $(BENCH_FOLDER)"
	$(Q)$(MAKE) --no-print-directory -C $(BENCH_FOLDER) $(MAKECMDGOALS)

#PATTERN RULES
$(BUILD_DIR)/%.o:  %.c
	@echo "===>  COMPILE  $@"
	$(Q)$(CC) -c $(DEBUG_FLAGS) $(CFLAGS) $(ANSI_CFLAGS) $(CPPFLAGS) $< -o $@
	$(Q)$(CC) $(DEBUG_FLAGS) $(CPPFLAGS) -MT $(@:.d=.o) -MM  $< > $(BUILD_DIR)/$*.d

$(BUILD_DIR)/%.o:  %.cc
	@echo "===>  COMPILE  $@"
	$(Q)$(CXX) -c $(DEBUG_FLAGS) $(CXXFLAGS) $(CPPFLAGS) $< -o $@
	$(Q)$(CXX) $(DEBUG_FLAGS) $(CXXFLAGS) $(CPPFLAGS) -MT $(@:.d=.o) -MM  $< > $(BUILD_DIR)/$*.d

$(BUILD_DIR)/%.o:  %.S
	@echo "===>  COMPILE  $@"
	$(Q)$(CPP) $(CPPFLAGS) $< -o $@.tmp
	$(Q)$(AS) $(ASFLAGS) $@.tmp -o $@
	@rm $@.tmp

$(BUILD_DIR)/%.h:  $(SRC_DIR)/includes/%.txt
	@echo "===>  GENERATE HEADER $@"
	$(Q)$(GEN_PMHEADER) $< $@

ifeq ($(findstring $(MAKECMDGOALS),clean),)
-include $(OBJ:.o=.d)
endif

.PHONY: clean distclean install uninstall help $(TARGET_LUA_LIB) $(TARGET_HWLOC_LIB) $(TARGET_GOTCHA_LIB) $(BENCH_TARGET)

.PRECIOUS: $(BUILD_DIR)/%.pas

.NOTPARALLEL:

clean: $(TARGET_LUA_LIB) $(TARGET_HWLOC_LIB) $(TARGET_GOTCHA_LIB) $(BENCH_TARGET)

=== examples/Makefile ===

include ../config.mk
include ../make/include_$(COMPILER).mk

LIKWID_BINDIR ?= $(PREFIX)/bin
LIKWID_INCLUDE ?= -I$(PREFIX)/include
LIKWID_LIBDIR ?= -L$(PREFIX)/lib
LIKWID_LIB ?= -llikwid
LIKWID_DEFINES ?= -DLIKWID_PERFMON

all: C-markerAPI C-likwidAPI F-markerAPI Lua-likwidAPI C-markerAPI-run C-likwidAPI-run Lua-likwidAPI-run F-markerAPI-run

help:
	@echo "Help message for examples included in LIKWID"
	@echo
	@echo "This folder contins examples how you can use the LIKWID API"
	@echo "Possible examples are:"
	@echo "- Marker API in C applications: C-markerAPI"
	@echo "- Marker API in Fortran applications: F-markerAPI"
	@echo "- Self Monitoring in C applications: C-likwidAPI"
	@echo "- Using the LIKWID API in Lua scripts: Lua-likwidAPI"
	@echo "- Monitoring a system with LIKWID: monitoring"
	@echo
	@echo "To build an example put the name behind make, e.g. make C-likwidAPI"
	@echo "To run the built example append '-run' to the name and add it to make: make C-likwidAPI-run"

C-markerAPI:
	$(CC) -fopenmp $(LIKWID_DEFINES) $(LIKWID_INCLUDE) $(LIKWID_LIBDIR) C-markerAPI.c -o C-markerAPI $(LIKWID_LIB) -lm

C-markerAPI-run: C-markerAPI
	LD_LIBRARY_PATH=$(PREFIX)/lib $(LIKWID_BINDIR)/likwid-perfctr -C 0 -g INSTR_RETIRED_ANY:FIXC0 -m ./C-markerAPI

C-likwidAPI:
	$(CC) -fopenmp $(LIKWID_INCLUDE) $(LIKWID_LIBDIR) C-likwidAPI.c -o C-likwidAPI $(LIKWID_LIB) -lm

C-likwidAPI-run: C-likwidAPI
	./C-likwidAPI

C-internalMarkerAPI:
	$(CC) -g -fopenmp $(LIKWID_DEFINES) $(LIKWID_INCLUDE) $(LIKWID_LIBDIR) C-internalMarkerAPI.c -o C-internalMarkerAPI $(LIKWID_LIB) -lm

C-internalMarkerAPI-run: C-internalMarkerAPI
	LD_LIBRARY_PATH=$(PREFIX)/lib ./C-internalMarkerAPI

monitoring:
	$(CC) $(LIKWID_INCLUDE) $(LIKWID_LIBDIR) monitoring.c -o monitoring $(LIKWID_LIB) -lm

monitoring-run: monitoring
	./monitoring

F-markerAPI: F-markerAPI.F90
	@if [ -x $(FC) ]; then $(FC) -fopenmp $(LIKWID_DEFINES) $(LIKWID_INCLUDE) $(LIKWID_LIBDIR) F-markerAPI.F90 -o F-markerAPI $(LIKWID_LIB) -lm; else echo "No Fortran compiler found"; fi
F-markerAPI-run: F-markerAPI
	@if [ -x F-markerAPI ]; then $(LIKWID_BINDIR)/likwid-perfctr -C 0 -g INSTR_RETIRED_ANY:FIXC0 -m ./F-markerAPI; else echo "No executable F-markerAPI found"; fi


Lua-likwidAPI:
	sed -e "s+<PREFIX>+$(PREFIX)+g" Lua-likwidAPI.lua > Lua-likwidAPI
	chmod +x Lua-likwidAPI

Lua-likwidAPI-run: Lua-likwidAPI
	./Lua-likwidAPI

clean:
	rm -f C-markerAPI C-likwidAPI F-markerAPI Lua-likwidAPI monitoring C-internalMarkerAPI

.PHONY: clean C-markerAPI C-likwidAPI F-markerAPI Lua-likwidAPI monitoring C-internalMarkerAPI

=== kernel/Makefile ===
obj-m := enable_rdpmc.o
KERNELDIR ?= /lib/modules/$(shell uname -r)/build
PWD := $(shell pwd)

all:
	$(MAKE) -Wpacked -C $(KERNELDIR) M=$(PWD) modules

modules_install:
	install -m 666 enable_rdpmc.ko /lib/modules/$(shell uname -r)/extra/

clean:
	rm -f *.ko *.o modules.order Module.symvers enable_rdpmc.mod.c .enable_rdpmc*.cmd
	rm -rf .tmp_versions

=== ext/GOTCHA/Makefile ===
SRC_DIRS    = ./src
MAKE_DIR   = ../../make

#DO NOT EDIT BELOW

include ../../config.mk
include $(MAKE_DIR)/include_$(COMPILER).mk
include $(MAKE_DIR)/config_checks.mk
include $(MAKE_DIR)/config_defines.mk

CFLAGS    = -O2 -Wall -fPIC
INCLUDES  = -I./include
LIBS      = -lm -Wl,-E -ldl

Q         ?= @
ifeq ($(strip $(DEBUG)),true)
DEBUG_FLAGS = -g
else
DEBUG_FLAGS =
endif
ifeq ($(strip $(COMPILER)),MIC)
CFLAGS += -mmic
LFLAGS += -mmic
endif


#CONFIGURE BUILD SYSTEM
BUILD_DIR  = ./$(COMPILER)

VPATH     = $(SRC_DIRS)
FILES     = $(notdir $(foreach dir,$(SRC_DIRS),$(wildcard $(dir)/*.c)))
OBJ       = $(patsubst %.c, $(BUILD_DIR)/%.o, $(FILES))

CPPFLAGS := $(CPPFLAGS) $(DEFINES) $(INCLUDES)
CPPFLAGS := $(filter-out -D_GNU_SOURCE,$(CPPFLAGS))


LIBGOTCHA = $(shell basename $(TARGET_GOTCHA_LIB))
INTERPRETER = lua

.NOTPARALLEL: all

all: $(BUILD_DIR) $(OBJ)  $(LIBGOTCHA)

$(BUILD_DIR):
	@mkdir $(BUILD_DIR)

$(STATIC_LIBGOTCHA): $(OBJ)
	$(info "GOTCHA cannot be build statically in LIKWID")
	#$(Q)${AR} -cq $(LIBGOTCHA) $(OBJ)

$(SHARED_LIBGOTCHA): $(OBJ)
	$(Q)$(CC) $(LFLAGS) -Wl,-soname,$(LIBGOTCHA).$(VERSION).$(RELEASE) -shared -fPIC -o $(LIBGOTCHA) $(OBJ) $(LIBS)

#PATTERN RULES
$(BUILD_DIR)/%.o:  %.c
	$(Q)$(CC) -c $(DEBUG_FLAGS) $(CFLAGS) $(CPPFLAGS) $< -o $@
	$(Q)$(CC) $(DEBUG_FLAGS) $(CPPFLAGS) -MT $(@:.d=.o) -MM  $< > $(BUILD_DIR)/$*.d

ifeq ($(findstring $(MAKECMDGOALS),clean),)
-include $(OBJ:.o=.d)
endif

.PHONY: clean distclean

clean:
	@rm -f $(TARGET) $(SHARED_LIBGOTCHA) $(STATIC_LIBGOTCHA) $(LIBGOTCHA).$(VERSION).$(RELEASE) $(LIBGOTCHA).$(VERSION)

distclean: clean
	@rm -f $(TARGET) $(SHARED_LIBGOTCHA) $(STATIC_LIBGOTCHA) $(LIBGOTCHA).$(VERSION).$(RELEASE) $(LIBGOTCHA).$(VERSION)
	@rm -rf $(BUILD_DIR)

=== ext/hwloc/Makefile ===
SRC_DIRS    = ./hwloc
MAKE_DIR   = ../../make

#DO NOT EDIT BELOW

include ../../config.mk
include $(MAKE_DIR)/include_$(COMPILER).mk
include $(MAKE_DIR)/config_checks.mk
include $(MAKE_DIR)/config_defines.mk

CFLAGS    = -O2 -Wall -fPIC -fvisibility=hidden
INCLUDES  += -I./include
#DEFINES   =
LIBS      = -L. -lm
LFLAGS    = -fPIC -fvisibility=hidden
Q         ?= @
DEFINES := $(filter-out -DVERSION=$(VERSION),$(DEFINES)) -DRUNSTATEDIR=\"/var/run\"
ifeq ($(DEBUG),true)
DEBUG_FLAGS = -g
else
DEBUG_FLAGS =
endif
ifeq ($(COMPILER),MIC)
CFLAGS += -mmic
LFLAGS += -mmic
endif


#CONFIGURE BUILD SYSTEM
BUILD_DIR  = ./$(COMPILER)

VPATH     = $(SRC_DIRS)
FILES     = $(notdir $(foreach dir,$(SRC_DIRS),$(wildcard $(dir)/*.c)))
OBJ       = $(patsubst %.c, $(BUILD_DIR)/%.o, $(FILES))
LIBHWLOC = $(shell basename $(TARGET_HWLOC_LIB))
ifeq ($(strip $(COMPILER)), GCCARMv7)
OBJ := $(filter-out $(BUILD_DIR)/topology-x86.o, $(OBJ))
endif
ifeq ($(strip $(COMPILER)), GCCARMv8)
OBJ := $(filter-out $(BUILD_DIR)/topology-x86.o, $(OBJ))
endif
ifeq ($(strip $(COMPILER)), ARMCLANG)
OBJ := $(filter-out $(BUILD_DIR)/topology-x86.o, $(OBJ))
endif
ifeq ($(COMPILER),GCCPOWER)
OBJ := $(filter-out $(BUILD_DIR)/topology-x86.o,$(OBJ))
endif
ifeq ($(COMPILER),XLC)
OBJ := $(filter-out $(BUILD_DIR)/topology-x86.o,$(OBJ))
endif


CPPFLAGS := $(CPPFLAGS) $(DEFINES) $(INCLUDES)

.NOTPARALLEL: all

all: $(BUILD_DIR) $(OBJ) $(LIBHWLOC)

$(BUILD_DIR):
	@mkdir $(BUILD_DIR)


$(STATIC_LIBHWLOC): $(OBJ)
	$(Q)${AR} -cq $(LIBHWLOC) $(OBJ)

$(SHARED_LIBHWLOC): $(OBJ)
	$(Q)$(CC) $(DEBUG_FLAGS) $(LFLAGS) -Wl,-soname,$(LIBHWLOC).$(VERSION).$(RELEASE)  -Wall -shared -fPIC -o $(LIBHWLOC) $(OBJ) $(LIBS) $(RPATHS)

#PATTERN RULES
$(BUILD_DIR)/%.o:  %.c
	$(Q)$(CC) -c $(DEBUG_FLAGS) $(CFLAGS) $(CPPFLAGS) $< -o $@
	$(Q)$(CC) $(DEBUG_FLAGS) $(CPPFLAGS) -MT $(@:.d=.o) -MM  $< > $(BUILD_DIR)/$*.d

ifeq ($(findstring $(MAKECMDGOALS),clean),)
-include $(OBJ:.o=.d)
endif

.PHONY: clean distclean

clean:
	@rm -f $(TARGET) $(SHARED_LIBHWLOC) $(STATIC_LIBHWLOC) $(LIBHWLOC).$(VERSION).$(RELEASE) $(LIBHWLOC).$(VERSION)

distclean: clean
	@rm -f $(TARGET) $(SHARED_LIBHWLOC) $(STATIC_LIBHWLOC) $(LIBHWLOC).$(VERSION).$(RELEASE) $(LIBHWLOC).$(VERSION)
	@rm -rf $(BUILD_DIR)

=== src/access-daemon/Makefile ===
# =======================================================================================
#
#      Filename:  Makefile
#
#      Description:  accessDaemon Makefile
#
#      Version:   5.1.0
#      Released:  20.11.2020
#
#      Author:  Jan Treibig (jt), jan.treibig@gmail.com
#      Project:  likwid
#
#      Copyright (C) 2020 RRZE, University Erlangen-Nuremberg
#
#      This program is free software: you can redistribute it and/or modify it under
#      the terms of the GNU General Public License as published by the Free Software
#      Foundation, either version 3 of the License, or (at your option) any later
#      version.
#
#      This program is distributed in the hope that it will be useful, but WITHOUT ANY
#      WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
#      PARTICULAR PURPOSE.  See the GNU General Public License for more details.
#
#      You should have received a copy of the GNU General Public License along with
#      this program.  If not, see <http://www.gnu.org/licenses/>.
#
# =======================================================================================

include  ../../config.mk
include  ../../make/include_$(COMPILER).mk

DAEMON_TARGET = likwid-accessD
SETFREQ_TARGET = likwid-setFreq
APPDAEMON_TARGET = likwid-appDaemon.so
GOTCHA_FOLDER = ../../ext/GOTCHA
Q         ?= @

DEFINES   += -D_GNU_SOURCE -DMAX_NUM_THREADS=$(MAX_NUM_THREADS) -DMAX_NUM_NODES=$(MAX_NUM_NODES) -DLIKWIDLOCK=$(LIKWIDLOCKPATH) -DLIKWIDSOCKETBASE=$(LIKWIDSOCKETBASE)
ifeq ($(DEBUG),true)
DEFINES += -DDEBUG_LIKWID
endif
INCLUDES  = -I../includes
CFLAGS    += -std=c99 -fPIC -pie -fPIE -fstack-protector
ifeq ($(COMPILER),GCCX86)
CFLAGS    +=  -m32
endif
CPPFLAGS :=  $(DEFINES) $(INCLUDES)

ifeq ($(COMPILER),GCCARMv8)
all:
else
all: $(DAEMON_TARGET) $(SETFREQ_TARGET) $(APPDAEMON_TARGET)
endif

$(DAEMON_TARGET): accessDaemon.c
	$(Q)$(CC) $(CFLAGS) $(CPPFLAGS) -o ../../$(DAEMON_TARGET) accessDaemon.c

$(SETFREQ_TARGET): setFreqDaemon.c
	$(Q)$(CC) $(CFLAGS) $(CPPFLAGS) -o ../../$(SETFREQ_TARGET) setFreqDaemon.c

$(APPDAEMON_TARGET): $(GOTCHA_TARGET) appDaemon.c
	$(Q)$(CC) -shared -fPIC $(CPPFLAGS) -Wl,-soname,$(APPDAEMON_TARGET).$(VERSION).$(RELEASE) -fstack-protector -I. -I$(GOTCHA_FOLDER)/include  -L$(GOTCHA_FOLDER) appDaemon.c -o ../../$(APPDAEMON_TARGET)  -llikwid-gotcha

=== src/pthread-overload/Makefile ===
# =======================================================================================
#
#      Filename:  Makefile
#
#      Description:  pthread-overload Makefile
#
#      Version:   5.1.0
#      Released:  20.11.2020
#
#      Author:  Jan Treibig (jt), jan.treibig@gmail.com
#               Thomas Gruber (tr), thomas.roehl@googlemail.com
#
#      Project:  likwid
#
#      Copyright (C) 2020 RRZE, University Erlangen-Nuremberg
#
#      This program is free software: you can redistribute it and/or modify it under
#      the terms of the GNU General Public License as published by the Free Software
#      Foundation, either version 3 of the License, or (at your option) any later
#      version.
#
#      This program is distributed in the hope that it will be useful, but WITHOUT ANY
#      WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
#      PARTICULAR PURPOSE.  See the GNU General Public License for more details.
#
#      You should have received a copy of the GNU General Public License along with
#      this program.  If not, see <http://www.gnu.org/licenses/>.
#
# =======================================================================================

include  ../../config.mk
include  ../../make/include_$(COMPILER).mk
include  ../../make/config_checks.mk
include  ../../make/config_defines.mk

Q         ?= @

TARGET   = $(PINLIB)

ifneq ($(COLOR),NONE)
DEFINES += -DCOLOR=$(COLOR)
endif

DEFINES  += -DMAX_NUM_THREADS=$(MAX_NUM_THREADS) -D_GNU_SOURCE
INCLUDES += -I../includes
LIBS     += -ldl
CPPFLAGS := $(CPPFLAGS) $(DEFINES) $(INCLUDES)

all: $(TARGET)

$(TARGET): pthread-overload.c
	$(Q)$(CC) -Wl,-soname,$(TARGET).$(VERSION).$(RELEASE) $(CFLAGS) $(ANSI_CFLAGS) $(CPPFLAGS) $(INCLUDES) $(SHARED_CFLAGS) $(SHARED_LFLAGS) -o ../../$(TARGET) pthread-overload.c $(LIBS)

=== ext/GOTCHA/src/CMakeLists.txt ===
include(GNUInstallDirs)
set(GOTCHA_SOURCES
  gotcha_utils.c 
  gotcha.c 
  gotcha_auxv.c 
  libc_wrappers.c 
  elf_ops.c 
  hash.c 
  tool.c 
  library_filters.c
  gotcha_dl.c
  translations.c
)

add_library(gotcha SHARED ${GOTCHA_SOURCES})


set_target_properties(gotcha PROPERTIES SOVERSION ${LIBTOOL_INTERFACE})
set_target_properties(gotcha PROPERTIES VERSION "${LIBTOOL_INTERFACE}.${LIBTOOL_REVISION}.${LIBTOOL_AGE}")
set_target_properties(gotcha PROPERTIES COMPILE_FLAGS "-fvisibility=${DEFAULT_SYMBOL_VISIBILITY}")
set_target_properties(gotcha PROPERTIES LINK_FLAGS "-fvisibility=${DEFAULT_SYMBOL_VISIBILITY}")
if(GOTCHA_ENABLE_TESTS)
add_library(gotcha_no_libc SHARED ${GOTCHA_SOURCES})
set_target_properties(gotcha_no_libc PROPERTIES SOVERSION ${LIBTOOL_INTERFACE})
set_target_properties(gotcha_no_libc PROPERTIES VERSION "${LIBTOOL_INTERFACE}.${LIBTOOL_REVISION}.${LIBTOOL_AGE}")
set_target_properties(gotcha_no_libc PROPERTIES COMPILE_DEFINITIONS "FORCE_NO_LIBC")
set_target_properties(gotcha_no_libc PROPERTIES COMPILE_FLAGS "-fvisibility=${DEFAULT_SYMBOL_VISIBILITY}")
set_target_properties(gotcha_no_libc PROPERTIES LINK_FLAGS "-fvisibility=${DEFAULT_SYMBOL_VISIBILITY}")
endif()

include_directories(${CMAKE_CURRENT_SOURCE_DIR})

install(TARGETS gotcha EXPORT gotcha-targets DESTINATION ${CMAKE_INSTALL_LIBDIR}) 
install(EXPORT gotcha-targets DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/gotcha)

add_subdirectory(example)

=== ext/GOTCHA/src/example/minimal/CMakeLists.txt ===
add_library(wrap_me SHARED sampleLib.c)
add_executable(symb_look symbolLookup.c)
target_link_libraries(wrap_me gotcha)
target_link_libraries(symb_look wrap_me gotcha)

=== debian/changelog ===
likwid (5.1.0+dfsg1-1) unstable; urgency=medium

  [ Christoph Martin ]
  * New upstream version 5.1.0+dfsg1

 -- Christoph Martin <martin@uni-mainz.de>  Mon, 18 Jan 2021 16:58:59 +0100

=== debian/control ===
Source: likwid
Maintainer: Christoph Martin <martin@uni-mainz.de>
Section: misc
Priority: optional
Standards-Version: 3.9.8
Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.16.1~), gfortran, liblua5.2-dev
Homepage: https://github.com/rrze-likwid/likwid
Vcs-Git: https://salsa.debian.org/debian/likwid.git
Vcs-Browser: https://salsa.debian.org/debian/likwid

Package: likwid
Architecture: amd64 i386 x32
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}, ${perl:Depends}, lua5.2
Suggests: feedgnuplot
Description: toolsuite for performance oriented programmers
 Likwid is a simple to install and use toolsuite of command line applications
 for performance oriented programmers. It works for Intel and AMD processors
 on the Linux operating system.
 .
 It consists of:
 .
 likwid-topology       - print thread and cache topology
 likwid-features       - view and toggle feature reagister on Intel processors
 likwid-perfctr        - configure and read out hardware performance counters
                         on Intel and AMD processors
 likwid-powermeter     - read out RAPL Energy information and get info about
                         Turbo Mode steps
 likwid-setFrequencies - read out RAPL Energy information and get info about
                         Turbo Mode steps
 likwid-memsweeper     - cleans up filled NUMA memory domains and evicts dirty
                         cacheline from cache hierarchy
 likwid-pin            - pin your threaded application (pthread, Intel and gcc
                         OpenMP to dedicated processors
 likwid-bench          - Micro benchmarking platform
 likwid-gencfg         - Dumps topology information to a file
 likwid-mpirun         - Wrapper to start MPI and Hybrid MPI/OpenMP
                         applications (Supports Intel MPI and OpenMPI)
 likwid-scope          - Frontend to the timeline mode of likwid-perfctr, plots
                         live graphs of performance metrics

## likwid 5.2.1+dfsg1

=== Makefile ===
--- 
+++ 
@@ -4,13 +4,13 @@
 #
 #      Description:  Central Makefile
 #
-#      Version:   5.1.0
-#      Released:  20.11.2020
+#      Version:   5.2.1
+#      Released:  03.12.2021
 #
 #      Author:  Jan Treibig (jt), jan.treibig@gmail.com
 #      Project:  likwid
 #
-#      Copyright (C) 2020 RRZE, University Erlangen-Nuremberg
+#      Copyright (C) 2021 NHR@FAU, University Erlangen-Nuremberg
 #
 #      This program is free software: you can redistribute it and/or modify it under
 #      the terms of the GNU General Public License as published by the Free Software
@@ -47,11 +47,15 @@
 include $(MAKE_DIR)/config_checks.mk
 include $(MAKE_DIR)/config_defines.mk
 
-INCLUDES  += -I./src/includes -I$(LUA_INCLUDE_DIR) -I$(HWLOC_FOLDER)/include -I$(BUILD_DIR)
+INCLUDES  += -I./src/includes -I$(LUA_INCLUDE_DIR) -I$(HWLOC_INCLUDE_DIR) -I$(BUILD_DIR)
 LIBS      += -ldl
 
 ifeq ($(LUA_INTERNAL),false)
 LIBS      += -l$(LUA_LIB_NAME)
+endif
+ifeq ($(USE_INTERNAL_HWLOC),false)
+LIBS      += -l$(HWLOC_LIB_NAME)
+SHARED_CFLAGS += -L$(HWLOC_LIB_DIR)
 endif
 
 #CONFIGURE BUILD SYSTEM
@@ -77,6 +81,7 @@
 OBJ := $(filter-out $(BUILD_DIR)/access_x86.o,$(OBJ))
 OBJ := $(filter-out $(BUILD_DIR)/access_x86_msr.o,$(OBJ))
 OBJ := $(filter-out $(BUILD_DIR)/access_x86_pci.o,$(OBJ))
+OBJ := $(filter-out $(BUILD_DIR)/access_x86_rdpmc.o,$(OBJ))
 OBJ := $(filter-out $(BUILD_DIR)/access_x86_clientmem.o,$(OBJ))
 else
 OBJ := $(filter-out $(BUILD_DIR)/loadDataARM.o,$(OBJ))
@@ -87,6 +92,18 @@
 OBJ := $(filter-out $(BUILD_DIR)/access_x86.o,$(OBJ))
 OBJ := $(filter-out $(BUILD_DIR)/access_x86_msr.o,$(OBJ))
 OBJ := $(filter-out $(BUILD_DIR)/access_x86_pci.o,$(OBJ))
+OBJ := $(filter-out $(BUILD_DIR)/access_x86_rdpmc.o,$(OBJ))
+OBJ := $(filter-out $(BUILD_DIR)/access_x86_clientmem.o,$(OBJ))
+else
+OBJ := $(filter-out $(BUILD_DIR)/loadDataARM.o,$(OBJ))
+endif
+ifeq ($(COMPILER), FCC)
+OBJ := $(filter-out $(BUILD_DIR)/topology_cpuid.o,$(OBJ))
+OBJ := $(filter-out $(BUILD_DIR)/loadData.o,$(OBJ))
+OBJ := $(filter-out $(BUILD_DIR)/access_x86.o,$(OBJ))
+OBJ := $(filter-out $(BUILD_DIR)/access_x86_msr.o,$(OBJ))
+OBJ := $(filter-out $(BUILD_DIR)/access_x86_pci.o,$(OBJ))
+OBJ := $(filter-out $(BUILD_DIR)/access_x86_rdpmc.o,$(OBJ))
 OBJ := $(filter-out $(BUILD_DIR)/access_x86_clientmem.o,$(OBJ))
 else
 OBJ := $(filter-out $(BUILD_DIR)/loadDataARM.o,$(OBJ))
@@ -98,6 +115,7 @@
 OBJ := $(filter-out $(BUILD_DIR)/access_x86_msr.o,$(OBJ))
 OBJ := $(filter-out $(BUILD_DIR)/access_x86_pci.o,$(OBJ))
 OBJ := $(filter-out $(BUILD_DIR)/access_x86_clientmem.o,$(OBJ))
+OBJ := $(filter-out $(BUILD_DIR)/access_x86_rdpmc.o,$(OBJ))
 else
 OBJ := $(filter-out $(BUILD_DIR)/loadDataARM.o,$(OBJ))
 endif
@@ -112,6 +130,7 @@
 OBJ := $(filter-out $(BUILD_DIR)/access_x86_msr.o,$(OBJ))
 OBJ := $(filter-out $(BUILD_DIR)/access_x86_pci.o,$(OBJ))
 OBJ := $(filter-out $(BUILD_DIR)/access_x86_clientmem.o,$(OBJ))
+OBJ := $(filter-out $(BUILD_DIR)/access_x86_rdpmc.o,$(OBJ))
 OBJ := $(filter-out $(BUILD_DIR)/loadData.o,$(OBJ))
 endif
 ifeq ($(COMPILER),XLC)
@@ -120,6 +139,7 @@
 OBJ := $(filter-out $(BUILD_DIR)/access_x86_msr.o,$(OBJ))
 OBJ := $(filter-out $(BUILD_DIR)/access_x86_pci.o,$(OBJ))
 OBJ := $(filter-out $(BUILD_DIR)/access_x86_clientmem.o,$(OBJ))
+OBJ := $(filter-out $(BUILD_DIR)/access_x86_rdpmc.o,$(OBJ))
 OBJ := $(filter-out $(BUILD_DIR)/loadData.o,$(OBJ))
 endif
 PERFMONHEADERS  = $(patsubst $(SRC_DIR)/includes/%.txt, $(BUILD_DIR)/%.h,$(wildcard $(SRC_DIR)/includes/*.txt))
@@ -262,44 +282,17 @@
 	@echo "===>  ENTER  $(GOTCHA_FOLDER)"
 	$(Q)$(MAKE) --no-print-directory -C $(GOTCHA_FOLDER) $(MAKECMDGOALS)
 
-
+ifeq ($(USE_INTERNAL_HWLOC),true)
 $(TARGET_HWLOC_LIB):
 	@echo "===>  ENTER  $(HWLOC_FOLDER)"
 	$(Q)$(MAKE) --no-print-directory -C $(HWLOC_FOLDER) $(MAKECMDGOALS)
+else
+$(TARGET_HWLOC_LIB):
+	@echo "===>  EXTERNAL HWLOC"
+endif
+
 
 $(BENCH_TARGET):
 	@echo "===>  ENTER  $(BENCH_FOLDER)"
 	$(Q)$(MAKE) --no-print-directory -C $(BENCH_FOLDER) $(MAKECMDGOALS)
 
-#PATTERN RULES
-$(BUILD_DIR)/%.o:  %.c
-	@echo "===>  COMPILE  $@"
-	$(Q)$(CC) -c $(DEBUG_FLAGS) $(CFLAGS) $(ANSI_CFLAGS) $(CPPFLAGS) $< -o $@
-	$(Q)$(CC) $(DEBUG_FLAGS) $(CPPFLAGS) -MT $(@:.d=.o) -MM  $< > $(BUILD_DIR)/$*.d
-
-$(BUILD_DIR)/%.o:  %.cc
-	@echo "===>  COMPILE  $@"
-	$(Q)$(CXX) -c $(DEBUG_FLAGS) $(CXXFLAGS) $(CPPFLAGS) $< -o $@
-	$(Q)$(CXX) $(DEBUG_FLAGS) $(CXXFLAGS) $(CPPFLAGS) -MT $(@:.d=.o) -MM  $< > $(BUILD_DIR)/$*.d
-
-$(BUILD_DIR)/%.o:  %.S
-	@echo "===>  COMPILE  $@"
-	$(Q)$(CPP) $(CPPFLAGS) $< -o $@.tmp
-	$(Q)$(AS) $(ASFLAGS) $@.tmp -o $@
-	@rm $@.tmp
-
-$(BUILD_DIR)/%.h:  $(SRC_DIR)/includes/%.txt
-	@echo "===>  GENERATE HEADER $@"
-	$(Q)$(GEN_PMHEADER) $< $@
-
-ifeq ($(findstring $(MAKECMDGOALS),clean),)
--include $(OBJ:.o=.d)
-endif
-
-.PHONY: clean distclean install uninstall help $(TARGET_LUA_LIB) $(TARGET_HWLOC_LIB) $(TARGET_GOTCHA_LIB) $(BENCH_TARGET)
-
-.PRECIOUS: $(BUILD_DIR)/%.pas
-
-.NOTPARALLEL:
-
-clean: $(TARGET_LUA_LIB) $(TARGET_HWLOC_LIB) $(TARGET_GOTCHA_LIB) $(BENCH_TARGET)

=== ext/hwloc/Makefile ===
--- 
+++ 
@@ -8,7 +8,7 @@
 include $(MAKE_DIR)/config_checks.mk
 include $(MAKE_DIR)/config_defines.mk
 
-CFLAGS    = -O2 -Wall -fPIC -fvisibility=hidden
+CFLAGS    = -O2 -fPIC -fvisibility=hidden
 INCLUDES  += -I./include
 #DEFINES   =
 LIBS      = -L. -lm
@@ -40,6 +40,9 @@
 OBJ := $(filter-out $(BUILD_DIR)/topology-x86.o, $(OBJ))
 endif
 ifeq ($(strip $(COMPILER)), ARMCLANG)
+OBJ := $(filter-out $(BUILD_DIR)/topology-x86.o, $(OBJ))
+endif
+ifeq ($(strip $(COMPILER)), FCC)
 OBJ := $(filter-out $(BUILD_DIR)/topology-x86.o, $(OBJ))
 endif
 ifeq ($(COMPILER),GCCPOWER)

=== src/access-daemon/Makefile ===
--- 
+++ 
@@ -4,13 +4,13 @@
 #
 #      Description:  accessDaemon Makefile
 #
-#      Version:   5.1.0
-#      Released:  20.11.2020
+#      Version:   5.2.1
+#      Released:  03.12.2021
 #
 #      Author:  Jan Treibig (jt), jan.treibig@gmail.com
 #      Project:  likwid
 #
-#      Copyright (C) 2020 RRZE, University Erlangen-Nuremberg
+#      Copyright (C) 2021 NHR@FAU, University Erlangen-Nuremberg
 #
 #      This program is free software: you can redistribute it and/or modify it under
 #      the terms of the GNU General Public License as published by the Free Software

=== src/pthread-overload/Makefile ===
--- 
+++ 
@@ -4,15 +4,15 @@
 #
 #      Description:  pthread-overload Makefile
 #
-#      Version:   5.1.0
-#      Released:  20.11.2020
+#      Version:   5.2.1
+#      Released:  03.12.2021
 #
 #      Author:  Jan Treibig (jt), jan.treibig@gmail.com
 #               Thomas Gruber (tr), thomas.roehl@googlemail.com
 #
 #      Project:  likwid
 #
-#      Copyright (C) 2020 RRZE, University Erlangen-Nuremberg
+#      Copyright (C) 2021 NHR@FAU, University Erlangen-Nuremberg
 #
 #      This program is free software: you can redistribute it and/or modify it under
 #      the terms of the GNU General Public License as published by the Free Software

=== debian/changelog ===
likwid (5.2.1+dfsg1-2) unstable; urgency=medium

  * enable usage of system hwloc
  * update to lua 5.3

 -- Christoph Martin <martin@uni-mainz.de>  Wed, 15 Jun 2022 17:54:21 +0200

likwid (5.2.1+dfsg1-1) unstable; urgency=medium

  [ Christoph Martin ]
  * New upstream version 5.2.1+dfsg1

 -- Christoph Martin <martin@uni-mainz.de>  Tue, 14 Jun 2022 10:17:33 +0200

likwid (5.1.0+dfsg1-2) UNRELEASED; urgency=medium

  * Remove constraints unnecessary since buster:
    + Build-Depends: Drop versioned constraint on debhelper and dpkg-dev.

 -- Debian Janitor <janitor@jelmer.uk>  Sun, 12 Sep 2021 05:48:18 -0000

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Section: misc
 Priority: optional
 Standards-Version: 3.9.8
-Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.16.1~), gfortran, liblua5.2-dev
+Build-Depends: debhelper, gfortran, liblua5.3-dev, libhwloc-dev
 Homepage: https://github.com/rrze-likwid/likwid
 Vcs-Git: https://salsa.debian.org/debian/likwid.git
 Vcs-Browser: https://salsa.debian.org/debian/likwid
@@ -11,7 +11,7 @@
 Package: likwid
 Architecture: amd64 i386 x32
 Pre-Depends: ${misc:Pre-Depends}
-Depends: ${shlibs:Depends}, ${misc:Depends}, ${perl:Depends}, lua5.2
+Depends: ${shlibs:Depends}, ${misc:Depends}, ${perl:Depends}, lua5.3
 Suggests: feedgnuplot
 Description: toolsuite for performance oriented programmers
  Likwid is a simple to install and use toolsuite of command line applications

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/architecture.mk

DCPPFLAGS=$(CPPFLAGS)
DLDFLAGS=$(LDFLAGS)

export DCPPFLAGS DLDFLAGS

%:
	dh $@

override_dh_auto_clean:
	mkdir ext/lua
	touch ext/lua/liblikwid-lua.so
	dh_auto_clean

override_dh_auto_build:
	$(MAKE) PREFIX=/usr LIBPREFIX=/usr/lib/$(DEB_BUILD_GNU_TYPE) INSTALLED_LIBPREFIX=/usr/lib/$(DEB_BUILD_GNU_TYPE) RPATHS= FORTRAN_INTERFACE=true

override_dh_auto_install:
	$(MAKE) PREFIX=$$(pwd)/debian/likwid/usr INSTALLED_PREFIX=/usr FORTRAN_INTERFACE=true MANPREFIX=$$(pwd)/debian/likwid/usr/share/man LIBPREFIX=$$(pwd)/debian/likwid/usr/lib/$(DEB_BUILD_GNU_TYPE) install

## likwid 5.2.2%2Bdfsg1

=== ext/GOTCHA/include/CMakeLists.txt ===
install(DIRECTORY gotcha DESTINATION include FILES_MATCHING PATTERN *.h)

=== debian/changelog ===
likwid (5.2.2+dfsg1-2) unstable; urgency=medium

  * fix clean target (closes: Bug#1046064)
  * wrap-and-sort debian/* files

 -- Christoph Martin <martin@uni-mainz.de>  Mon, 04 Sep 2023 14:08:52 +0200

likwid (5.2.2+dfsg1-1) unstable; urgency=medium

  * remove hwloc and cleanup copyright
  * New upstream version 5.2.2+dfsg1
  * replace DEB_BUILD_GNU_TYPE with DEB_HOST_MULTIARCH (closes: 950368)

 -- Christoph Martin <martin@uni-mainz.de>  Fri, 02 Sep 2022 15:54:43 +0200

likwid (5.2.1+dfsg1-3) unstable; urgency=medium

  * remove obsolete symlink to custom hwloc lib (closes: 1013179)
  * remove hwloc from lintian overrides
  * update watch file src to https
  * add python3 to deps

 -- Christoph Martin <martin@uni-mainz.de>  Mon, 20 Jun 2022 17:31:59 +0200

=== debian/control ===
--- 
+++ 
@@ -3,16 +3,29 @@
 Section: misc
 Priority: optional
 Standards-Version: 3.9.8
-Build-Depends: debhelper, gfortran, liblua5.3-dev, libhwloc-dev
+Build-Depends:
+ debhelper,
+ dh-python,
+ gfortran,
+ libhwloc-dev,
+ liblua5.3-dev,
+ python3,
 Homepage: https://github.com/rrze-likwid/likwid
 Vcs-Git: https://salsa.debian.org/debian/likwid.git
 Vcs-Browser: https://salsa.debian.org/debian/likwid
 
 Package: likwid
 Architecture: amd64 i386 x32
-Pre-Depends: ${misc:Pre-Depends}
-Depends: ${shlibs:Depends}, ${misc:Depends}, ${perl:Depends}, lua5.3
-Suggests: feedgnuplot
+Pre-Depends:
+ ${misc:Pre-Depends},
+Depends:
+ lua5.3,
+ ${misc:Depends},
+ ${perl:Depends},
+ ${python3:Depends},
+ ${shlibs:Depends},
+Suggests:
+ feedgnuplot,
 Description: toolsuite for performance oriented programmers
  Likwid is a simple to install and use toolsuite of command line applications
  for performance oriented programmers. It works for Intel and AMD processors

## likwid 5.2.2+dfsg1

=== Makefile ===
--- 
+++ 
@@ -4,13 +4,13 @@
 #
 #      Description:  Central Makefile
 #
-#      Version:   5.2.1
-#      Released:  03.12.2021
+#      Version:   5.2.2
+#      Released:  26.07.2022
 #
 #      Author:  Jan Treibig (jt), jan.treibig@gmail.com
 #      Project:  likwid
 #
-#      Copyright (C) 2021 NHR@FAU, University Erlangen-Nuremberg
+#      Copyright (C) 2022 NHR@FAU, University Erlangen-Nuremberg
 #
 #      This program is free software: you can redistribute it and/or modify it under
 #      the terms of the GNU General Public License as published by the Free Software

=== src/access-daemon/Makefile ===
--- 
+++ 
@@ -4,13 +4,13 @@
 #
 #      Description:  accessDaemon Makefile
 #
-#      Version:   5.2.1
-#      Released:  03.12.2021
+#      Version:   5.2.2
+#      Released:  26.07.2022
 #
 #      Author:  Jan Treibig (jt), jan.treibig@gmail.com
 #      Project:  likwid
 #
-#      Copyright (C) 2021 NHR@FAU, University Erlangen-Nuremberg
+#      Copyright (C) 2022 NHR@FAU, University Erlangen-Nuremberg
 #
 #      This program is free software: you can redistribute it and/or modify it under
 #      the terms of the GNU General Public License as published by the Free Software

=== src/pthread-overload/Makefile ===
--- 
+++ 
@@ -4,15 +4,15 @@
 #
 #      Description:  pthread-overload Makefile
 #
-#      Version:   5.2.1
-#      Released:  03.12.2021
+#      Version:   5.2.2
+#      Released:  26.07.2022
 #
 #      Author:  Jan Treibig (jt), jan.treibig@gmail.com
 #               Thomas Gruber (tr), thomas.roehl@googlemail.com
 #
 #      Project:  likwid
 #
-#      Copyright (C) 2021 NHR@FAU, University Erlangen-Nuremberg
+#      Copyright (C) 2022 NHR@FAU, University Erlangen-Nuremberg
 #
 #      This program is free software: you can redistribute it and/or modify it under
 #      the terms of the GNU General Public License as published by the Free Software

=== test/cmake/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5 FATAL_ERROR)

project(Likwid-Test LANGUAGES C)

find_package(likwid REQUIRED COMPONENTS marker OPTIONAL_COMPONENTS nvmarker)

message(STATUS "")
message(STATUS "likwid_FOUND: ${likwid_FOUND}")

foreach(_VAR LIKWID_INCLUDES LIKWID_LIBRARIES LIKWID_ROOT_DIR
    LIKWID_NVIDIA_INTERFACE LIKWID_FORTRAN_INTERFACE
    LIKWID_INCLUDE_DIR LIKWID_LIBRARY LIKWID_INCLUDE_DIRS
    LIKWID_LIBRARIES LIKWID_LIBRARY_DIRS)
    message(STATUS "${_VAR}: ${${_VAR}}")
endforeach()

foreach(_VAR ${LIKWID_EXECUTABLE_OPTIONS})
    message(STATUS "LIKWID_${_VAR}_EXECUTABLE: ${LIKWID_${_VAR}_EXECUTABLE}")
endforeach()

foreach(_VAR ${LIKWID_COMPONENT_OPTIONS})
    message(STATUS "likwid_${_VAR}_FOUND: ${likwid_${_VAR}_FOUND}")
endforeach()
message(STATUS "")

add_executable(test_install_tree ${PROJECT_SOURCE_DIR}/test.c)
target_link_libraries(test_install_tree PRIVATE likwid::likwid)

=== test/executable_tests/Makefile ===


all: topology pin markerAPI perfctr memsweeper powermeter bench genTopoCfg setFrequencies mpirun

topology:
	./tester.sh likwid-topology
pin:
	./tester.sh likwid-pin
perfctr: markerAPI
	./tester.sh likwid-perfctr
memsweeper:
	./tester.sh likwid-memsweeper
powermeter:
	./tester.sh likwid-powermeter
bench:
	./tester.sh likwid-bench
genTopoCfg:
	./tester.sh likwid-genTopoCfg
setFrequencies:
	./tester.sh likwid-setFrequencies
mpirun: mpipin markerAPI
	./tester.sh likwid-mpirun
markerAPI:
	make -s -C .. streamGCC
mpipin:
	make -s -C .. test-mpi

=== ext/GOTCHA/src/example/CMakeLists.txt ===
add_subdirectory(autotee)
add_subdirectory(minimal)

=== debian/control ===
--- 
+++ 
@@ -3,29 +3,16 @@
 Section: misc
 Priority: optional
 Standards-Version: 3.9.8
-Build-Depends:
- debhelper,
- dh-python,
- gfortran,
- libhwloc-dev,
- liblua5.3-dev,
- python3,
+Build-Depends: debhelper, dh-python, python3, gfortran, liblua5.3-dev, libhwloc-dev
 Homepage: https://github.com/rrze-likwid/likwid
 Vcs-Git: https://salsa.debian.org/debian/likwid.git
 Vcs-Browser: https://salsa.debian.org/debian/likwid
 
 Package: likwid
 Architecture: amd64 i386 x32
-Pre-Depends:
- ${misc:Pre-Depends},
-Depends:
- lua5.3,
- ${misc:Depends},
- ${perl:Depends},
- ${python3:Depends},
- ${shlibs:Depends},
-Suggests:
- feedgnuplot,
+Pre-Depends: ${misc:Pre-Depends}
+Depends: ${shlibs:Depends}, ${misc:Depends}, ${perl:Depends}, ${python3:Depends}, lua5.3
+Suggests: feedgnuplot
 Description: toolsuite for performance oriented programmers
  Likwid is a simple to install and use toolsuite of command line applications
  for performance oriented programmers. It works for Intel and AMD processors

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/architecture.mk

DCPPFLAGS=$(CPPFLAGS)
DLDFLAGS=$(LDFLAGS)

export DCPPFLAGS DLDFLAGS

%:
	dh $@ --with python3

override_dh_auto_clean:
	mkdir ext/lua
	touch ext/lua/liblikwid-lua.so
	dh_auto_clean

override_dh_auto_build:
	$(MAKE) PREFIX=/usr LIBPREFIX=/usr/lib/$(DEB_HOST_MULTIARCH) INSTALLED_LIBPREFIX=/usr/lib/$(DEB_HOST_MULTIARCH) RPATHS= FORTRAN_INTERFACE=true

override_dh_auto_install:
	$(MAKE) PREFIX=$$(pwd)/debian/likwid/usr INSTALLED_PREFIX=/usr FORTRAN_INTERFACE=true MANPREFIX=$$(pwd)/debian/likwid/usr/share/man LIBPREFIX=$$(pwd)/debian/likwid/usr/lib/$(DEB_HOST_MULTIARCH) install
